"check.input" <-
function(x, p, a, du, pi=NULL){
    if(length(x) != length(p)){
        stop("length(x) != length(p)\n")
    }
    
    if(!is.matrix(a) || nrow(a) != ncol(a) ){
        stop("transition matrix a must be a square matrix\n")
    }

    if(!is.matrix(du)){
        stop("du must be a matrix\n")
    }
    
    if(ncol(du) !=ncol(a) ){
        stop("number of columns of du and a must be the same\n")
    }
    
    if(!is.null(pi)){
        if(!is.vector(pi)){
            stop("pi must be a vector\n")
        }
        
        if(length(pi) != ncol(a)){
            stop("length of pi must equal to ncol(a)\n")
        }
    }
}

