"logsumexp" <-
function(v, cut=0.5){
    ## log(sum(exp(v)))
    v  = v[is.finite(v)]
    lv = length(v)
    if(lv==0){
        return(-Inf)
    }
    if(lv==1){
        return(v[1])
    }
    
    sv  = sort(v, decreasing=TRUE)
    res = sum(exp(sv[-1] - sv[1]))
    if(lv == 2 || res < cut){
        lse = sv[1] + res - res^2/2 + res^3/3 - res^4/4 + res^5/5
    }
    else{
        for(d in 2:(lv-1)){
            nv1 = logsumexp(sv[1:d])
            res = sum(exp(sv[-(1:d)] - nv1))
            if(res < cut){ break }
        }
        lse = nv1 + res - res^2/2 + res^3/3 - res^4/4 + res^5/5
    }
    lse
}

